/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package studentcatalog;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.Collections;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;
import java.util.Set;
import java.io.OutputStreamWriter;
import java.io.UnsupportedEncodingException;
import java.nio.charset.Charset;
import java.util.HashMap;
import java.util.Iterator;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 *
 * @author apple
 */
public class CatalogueImpl implements Catalogue {
    private Map<String,List<Results>> results = new HashMap<String,List<Results>>();

    public Set<String> getStudents() {
        return Collections.unmodifiableSet(results.keySet());
    }

    public List<Results> getGrades(String student) {
        return Collections.unmodifiableList(results.get(student));
    }

    public List<Integer> getGrades(String student, String study) {
        List<Integer> grades=new LinkedList<Integer>();
        for(Results result:results.get(student)){
            if(result.getStudy().equals(study)){
                grades.add(result.getGrade());
            }
        }
        return grades;
    }

    public void store(String filename) throws CatalogueException {
    }

    public void load(String filename) throws CatalogueException{
    }

    public void add(String student, String study, int grade) {
        List<Results> grades;

        if(results.containsKey(student)){
            grades = results.get(student);
        }else{
            grades = new LinkedList<Results>();
        }
        grades.add(new ResultsImpl(study,grade));
        results.put(student, grades);
    }

}
